<template>
  <PageCard
    class="signIn_wrapper"
    :title="$t('authorization.step3.part1.title')"
    :bordering="false"
    gradient>
    <div class="signIn_inner">
      <ul
        class="signIn_inner-description ul">
        <li
          v-for="(item, key) in $t('authorization.step3.part1.description')"
          :key="key">{{item}}
        </li>
      </ul>
      <div class="mt-20 mb-20">
        <BInput
          v-model="privateKey"
          style="border: 1px solid #3b4356; border-radius: 6px; overflow: hidden;"
          :placeholder="$t('authorization.step3.part1.placeholder')"
          color="#00bac3"></BInput>
      </div>
      <div class="signIn_inner-body flex flex-center">
        <BtnDark
          class="mr-10"
          :color="copied ? '#36d253' : '#8591a9'"
          borderColor="#36d253"
          v-if="!isIphone"
          @click="paste">{{$t('authorization.step3.part1.paste')}}
          <template slot="img">
            <IconCopy
              class="mt-3p ml-10"
              :fill="copied ? '#36d253' : '#8591a9'"></IconCopy>
          </template>
        </BtnDark>
        <Btn
          :class="isIphone ? '' : 'ml-10'"
          :disabled="!privateKey"
          @click="login"
          small>{{$t('authorization.login')}}
        </Btn>
      </div>
    </div>
  </PageCard>
</template>

<script>
  import BtnDark from '~/components/UI/BtnSign_dark';
  import {Wallet} from '~/services/wallet/';
  import Btn from '~/components/UI/BtnSign';
  import BInput from '~/components/UI/Input';
  import notification
    from '~/components/UI/Notification/main.js';
  import MobileDetect from 'mobile-detect';
  import IconCopy from '~/components/UI/icons/icon-copy';
  import PageCard from '~/components/UI/PageCard';

  export default {
    name: "Step3_ThePart1",
    props: {
      active: {
        type: Boolean,
        default: false
      }
    },
    data() {
      return {
        privateKey: '',
        isIphone: false,
        copied: false
      }
    },
    components: {
      BtnDark,
      Btn,
      BInput,
      IconCopy,
      PageCard
    },
    computed: {},
    watch: {
      privateKey: function () {
        let pk = this.privateKey;
        if (pk.length > 60) {
          const matched = pk.match(/5[1-9A-HJ-NP-Za-km-z]*/gi);
          let activeKey = '';
          let ownerKey = '';
          if (matched) {
            if (matched.length === 2) {
              activeKey = matched[0];
              ownerKey = matched[1];
            } else {
              activeKey = matched[0]
            }
          }
          this.privateKey = `${activeKey}:${ownerKey}`;
        }
      }
    },
    methods: {
      paste() {
        this.copied = true;
        navigator.clipboard && navigator.clipboard.readText && navigator.clipboard.readText().then(text => this.privateKey = text);
      },
      login() {
        this.checkKeys(this.privateKey);
      },
      onFileUpload(e) {
        if (e.target.files && e.target.files.length) {
          const file = e.target.files[0];
          const reader = new FileReader();
          reader.onload = () => {
            const keys = reader.result;
            this.checkKeys(keys);
            e.target && (e.target.value = null);
          };
          reader.readAsText(file);
        }
      },
      checkKeys(keys) {
        try {
          const privateKeys = keys.split(':');
          if (!Wallet.isValidPrivate(privateKeys)) {
            notification.info({
              message: 'Private key is not a valid',
            });
            return;
          }
          const publicKeys = Wallet.privateToPublic(privateKeys);
          this.$emit('finish', {
            privateKeys,
            publicKeys
          });
        } catch (e) {
          console.log('error check keys- ', e);
        }
        /*        try {
                  const privateKey = key;
                  console.log('private key is - ', privateKey);
                  if (!Wallet.isValidPrivate(privateKey)) {
                    console.log('key is not valid!');
                    return;
                  }
                  const publicKey = Wallet.privateToPublic(privateKey);
                  console.log('public - ', publicKey);
                  this.$emit('finish', {
                    publicKey,
                    privateKey
                  });
                } catch (e) {
                  console.log('error check keys- ', e);
                }*/
      }
    },
    mounted() {
      const md = new MobileDetect(navigator.userAgent);
      this.isIphone = md.is('iPhone');
    }
  }
</script>
